<template>

  <div class="main-page">
    <div class="main-banner">
      <swiper class="swiper" :options="swiperOption">
        <swiper-slide v-for="img in bannerImgs" :key="img">
          <div class="main-banner__img">
            <picture>
              <source media="(max-width: 500px)" type="image/webp" :srcset="`/images/${img}-750m.webp`">
              <source media="(max-width: 500px)" :srcset="`/images/${img}-750m.jpg`">

              <source media="(max-width: 1024px)" type="image/webp" :srcset="`/images/${img}-490.webp`">
              <source media="(max-width: 1024px)" :srcset="`/images/${img}-490.jpg`">

              <source type="image/webp" :srcset="`/images/${img}-600.webp`">
              <img :src="`/images/${img}-600.jpg`" alt="">
            </picture>
          </div>

        </swiper-slide>
      </swiper>

      <div class="container main-banner__content">
        <h1 class="main-banner__title">Сервис почасовой аренды</h1>
        <div class="main-banner__row">
          <div class="main-banner__filter dropdown__text-ellipsis"
               v-for="filter in filters" :key="filter.name"
               :class="filter.class"
          >

            <range-dropdown v-if="filter.dropdownType === 'range'"
                            :filter="filter"
                            @clearValue="filter.value = []"
            />

            <check-dropdown v-if="filter.dropdownType === 'check'"
                            :filter="filter"
                            @clearValue="filter.activeItems = []"
                            @setActiveItems="filter.activeItems = $event"
            />

            <date-dropdown v-if="filter.dropdownType === 'date'"
                           :filter="filter"
                           @clearValue="filter.selectedDate = null"
                           @setActiveDates="filter.selectedDate = $event"
            />

          </div>

          <a href="/places"
             class="main-banner__filter button button--green"
             @click="goToRooms"
          >Найти помещение</a>

        </div>
      </div>

    </div>

    <div class="container">
      <purpose :purposeItems="purposeItems"/>
    </div>

    <how-it-works></how-it-works>

    <div class="container">
      <pre-footer v-if="meta.content"
                  :content="meta.content"
                  :isMainPage="true"
      />
    </div>

  </div>
</template>

<script>
  import { mapActions } from 'vuex';

  import RangeDropdown from '../components/dropdown/RangeDropdown';
  import CheckDropdown from '../components/dropdown/CheckDropdown';
  import DateDropdown from '../components/dropdown/DateDropdown';
  import Purpose from '../components/Purpose';
  import PreFooter from '../components/PreFooter';
  import HowItWorks from '../components/HowItWorks';

  import getFiltredFilters from '../assets/js/helpers/get-filtred-filters';
  import getURLFilterQuery from '../assets/js/helpers/get-url-filter-query';

  import { getSeoBySlug } from '../service/deliroom-service';

  const filtersTemplate = [
    {
      dropdownType: 'date',
      type: 'date',
      selectedDate: null,
      class: 'main-banner__filter--date'
    },
    {
      dropdownType: 'range',
      type: 'time',
      label: '',
      value: [],
      values: [9, 22],
      flags: ['Утро', 'Вечер'],
      class: 'main-banner__filter--time',
    },
    {
      dropdownType: 'range',
      type: 'capacity',
      label: 'чел.',
      value: [],
      class: 'main-banner__filter--capacity',
    },
    {
      dropdownType: 'check',
      type: 'metro_station',
      shortName: 'Метро',
      activeItems: [],
      class: 'main-banner__filter--metro'
    },
  ];

  export default {
    name: 'mainPage',
    components: {
      HowItWorks,
      PreFooter,
      Purpose,
      DateDropdown,
      CheckDropdown,
      RangeDropdown
    },
    data: () => ({
      swiperOption: {
        spaceBetween: 30,
        centeredSlides: true,
        effect: 'fade',
        autoplay: {
          delay: 4500,
          disableOnInteraction: false
        }
      },
      bannerImgs: ['banner-1', 'banner-2', 'banner-3', 'banner-4'],
      purposeItems: [
        {
          icon: 'tutors',
          purpose: 'Психологи и&nbsp;репетиторы'
        },
        {
          icon: 'instructors',
          purpose: 'Инструкторы по йоге и&nbsp;массажисты'
        },
        {
          icon: 'training',
          purpose: 'Организаторы тренингов'
        },
        {
          icon: 'business',
          purpose: 'Бизнесмены и&nbsp;предприниматели'
        },
      ]
    }),

    asyncData: async (context) => {
      if (!context.store.state.filters.filters.length) {
        await context.store.dispatch('filters/getFilters');
      }

      const filters = getFiltredFilters(context.store.state.filters.filters, filtersTemplate);



      return {
        meta: await getSeoBySlug('/'),
        filters
      }
    },

    methods: {
      ...mapActions({
        getFilters: 'filters/getFilters'
      }),

      goToRooms(event) {
        event.preventDefault();

        this.$router.push({
          path: 'places',
          query: getURLFilterQuery(this.filters)
        })
      }
    },

    head() {
      if (!this.meta) return;

      return {
        title: this.meta.title,
        meta: this.meta.meta.map((metaItem) => ({
          ...metaItem,
          hid: metaItem.name.toLowerCase(),
          name: metaItem.name.toLowerCase(),
        })),
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .main-banner {
    position: relative;
    margin-top: rem(-120);

    &::before {
      content: '';

      position: absolute;
      top: 0;
      left: 0;
      right: 0;
      bottom: 0;
      z-index: 2;

      background: linear-gradient(rgba($black, 0.55), rgba($black, 0));
    }

    @media (max-width: $mobile-width) {
      margin-top: rem(-65);
    }

    &__img {
      height: rem(600);
      width: 100%;

      @media (max-width: $mobile-width) {
        height: 100vh;
      }

      img {
        width: 100%;
        height: 100%;

        object-fit: cover;
        object-position: center;
      }
    }

    &__content {
      position: absolute;
      z-index: 3;

      top: rem(230);
      left: 50%;
      transform: translateX(-50%);

      @media (max-width: $mobile-width) {
        top: 20vh;

        width: rem(352);
      }
    }

    &__title {
      @include h1;
      color: $white;

      margin-bottom: rem(40);

      @media (max-width: $mobile-width) {
        margin-bottom: 10vh;
      }
    }


    &__row {
      display: flex;
      align-items: center;

      @media (max-width: $mobile-width) {
        flex-flow: wrap;
        margin: rem(-4);
      }
    }

    &__filter {
      .button.dropdown__btn {
        box-shadow: none;
      }

      &.button {
        box-shadow: none;
      }

      & + & {
        margin-left: rem(4);
      }

      @media (max-width: $mobile-width) {
        margin: rem(4);

        &--date, &--time {
          flex: 1 1 rem(120);
          width: rem(120);
        }

        &--capacity, &--metro {
          flex: 1 1 rem(184);
          width: rem(184);
        }

        &--date {
          order: 0;
        }

        &--capacity {
          order: 1;
        }

        &--time {
          order: 2;
        }

        &--metro {
          order: 3;
        }

        &.button {
          flex: 0 0 calc(100% - .5rem);
          width: calc(100% - .5rem);
          order: 4;
        }
      }
    }

  }

</style>

